//define state
#define ON       0
#define OFF      1
#define BLINK    2

// keypad number
#define UP_KEY 1
#define DOWN_KEY 0
#define OK_KEY 2
#define CANCEL_KEY 3

#define NUM_KEYS 4

// adc preset value, represent top value,incl. noise & margin,that the adc reads, when a key is pressed
int  adc_key_val[NUM_KEYS] ={0, 210, 440, 660};

long previousMillis = 0;
long update_display_millis = 0;


unsigned char dp_count,dp;

unsigned char display_count,display;

struct Keypad
{
    byte button_count; // debounce counters
    byte button_status; // button status - pressed/released
    byte button_flag; // button on flags for user program 

    byte button_long_pressed;
    int button_count_long;   
};

Keypad key[NUM_KEYS];

struct DS1307_Time
{
    byte second; 
    byte minute;
    byte hour;
    byte wkDay;
    byte day;
    byte month;
    byte year;
    byte ctrl;
};

DS1307_Time time;

void setup()
{
   //Serial.begin(19200);
   init_ds1307();
   init_keypad();   
   init_SevenSegment();
}

void loop()
{
  
  byte i;
    for(i=0; i<NUM_KEYS; i++){
                 
        if(key[i].button_flag !=0)
        {            
           key[i].button_flag=0;  // reset button flag
           
 	    switch(i)
            {
      	    case UP_KEY:         
              //Serial.print(key[i].button_long_pressed,DEC);
              //Serial.println(",UP");             
              break;
    	    case DOWN_KEY:
              //Serial.print(key[i].button_long_pressed,DEC);    
              //Serial.println(",DOWN");
	      break;
            case OK_KEY:
               if (display == ON) 
                 display = OFF;
               else
                 display = ON;
              //Serial.print(key[i].button_long_pressed,DEC);            
              //Serial.println(",OK");                          
              break;   
            case CANCEL_KEY:
              //Serial.print(key[i].button_long_pressed,DEC);            
              //Serial.println(",CANCEL");
              break;
	    }

	}
      
  }
  
  if (key[OK_KEY].button_long_pressed == 1) {
      
      //time.hour = setupTime(time.hour);
      //time.minute = setupTime(time.minute);
      //time.second = setupTime(time.second);
      //setClock();    
      
      setupTime_hour();
      setupTime_minute();
      
      dp = OFF;
  }

  if (millis() - previousMillis > 1000) {    

    previousMillis = millis();   // remember the last time we blinked the LED
    
    dp = ON;    
    getClock();
    
  }

  if (millis() - update_display_millis > 4) {
    
    update_display_millis = millis();   // remember the last time we blinked the LED    
    
    displayClock();

    if (display_count > 150) {
        display = ON;
        display_count = 0;
    }
    
  }

}

void displayClock()
{     
  // Display RTC Clock

  if (display == 0) {
    byte digi1Dec = bcd2Dec(time.hour);
    byte digi2Dec = bcd2Dec(time.minute);    
    //byte secondDec = bcd2Dec(time.second);
        
    byte digi1 = digi1Dec /10;
    byte digi2 = digi1Dec %10;

    byte digi3 = digi2Dec /10;
    byte digi4 = digi2Dec %10;

    /*  
    byte digi5 = secondDec /10;
    byte digi6 = secondDec %10;
    */
    
    sevenSegment(digi1,OFF);
    ControlSegmentDigi(0);

    sevenSegment(digi2,dp);
    ControlSegmentDigi(1);
    
    if ((dp_count > 30) && (dp == ON)) {
      dp = OFF;
      dp_count = 0;
    }
  
    sevenSegment(digi3,OFF);
    ControlSegmentDigi(2);

    sevenSegment(digi4,OFF);
    ControlSegmentDigi(3);
    
  } else {
        
    byte digi1Dec = bcd2Dec(time.day);
    byte digi2Dec = bcd2Dec(time.month);
      
    byte digi1 = digi1Dec /10;
    byte digi2 = digi1Dec %10;

    byte digi3 = digi2Dec /10;
    byte digi4 = digi2Dec %10;
        
    sevenSegment(digi1,OFF);
    ControlSegmentDigi(0);

    sevenSegment(digi2,dp);
    ControlSegmentDigi(1);
    
    if ( (dp_count >30) && (dp == ON) ) {
      dp = OFF;
      dp_count=0;
    }
  
    sevenSegment(digi3,OFF);
    ControlSegmentDigi(2);

    sevenSegment(digi4,OFF);
    ControlSegmentDigi(3);

    display_count++;
  }  
    
}


byte setupTime(byte value)
{
  byte i,val; 
  
  val = bcd2Dec(value);
  
  while(1)
  {
    
    byte digi3 = val /10;
    byte digi4 = val %10;
      
    sevenSegment(digi3,OFF);
    ControlSegmentDigi(2);

    sevenSegment(digi4,OFF);
    ControlSegmentDigi(3);
            
    for(i=0; i<NUM_KEYS; i++){
                 
        if(key[i].button_flag !=0)
        {            
           key[i].button_flag=0;  // reset button flag
           
 	    switch(i)
            {
      	    case UP_KEY:
              val++;
              break;
    	    case DOWN_KEY:
              val--;
	      break;
            case OK_KEY:        
              return Dec2bcd(val);
              //STATE = 1;              
              break;   
            case CANCEL_KEY:
              //Serial.println("CANCEL");              
              return value;
	    }

	}
      
  }
   
  }

  
}


void setupTime_hour(void)
{
  byte i;
  byte val_minute,val_hour;
  byte STATE = 0;  

  val_hour = bcd2Dec(time.hour);    
        
  while(STATE == 0)
  {       
   
   if (millis() - update_display_millis > 4) {
       
    update_display_millis = millis(); 
    
    val_minute= bcd2Dec(time.minute);  
                
    byte digi1 = val_hour /10;
    byte digi2 = val_hour %10;
    
    byte digi3 = val_minute /10;
    byte digi4 = val_minute %10;

    sevenSegment(digi1 , dp);
    ControlSegmentDigi(0);

    sevenSegment(digi2 , dp);
    ControlSegmentDigi(1);
    
    if ((dp_count > 40) && (dp == BLINK )) {
      dp = OFF;
      dp_count = 0;
    }
    
    sevenSegment(digi3 ,OFF);
    ControlSegmentDigi(2);

    sevenSegment(digi4 ,OFF);
    ControlSegmentDigi(3);
    
   }
   
   
    if (millis() - previousMillis > 500) {
    
        previousMillis = millis();   // remember the last time we blinked the LED    

        getClock();        
    
        dp = BLINK;
    
    }
        
    for(i=0; i<NUM_KEYS; i++){
                 
        if(key[i].button_flag !=0)
        {            
           key[i].button_flag=0;  // reset button flag
           
 	    switch(i)
            {
      	    case UP_KEY:
              val_hour++;
              break;
    	    case DOWN_KEY:
              val_hour--;
	      break;
            case OK_KEY:        
              //return Dec2bcd(val);
              STATE = 1;              
              break;   
            case CANCEL_KEY:
              //Serial.println("CANCEL");              
              return;
	    }

	}

  if (val_hour > 24) val_hour = 0;
  if (val_hour < 0) val_hour = 23;
      
  }
   
  }

  time.hour = Dec2bcd(val_hour);
  
  setClock();
  
}


void setupTime_minute(void)
{
  byte i;
  byte val_minute,val_hour;
  byte STATE = 0;  

  val_minute= bcd2Dec(time.minute);  

        
  while(STATE == 0)
  {       
   
   if (millis() - update_display_millis > 4) {
       
    update_display_millis = millis(); 

    val_hour = bcd2Dec(time.hour);    
                    
    byte digi1 = val_hour /10;
    byte digi2 = val_hour %10;
    
    byte digi3 = val_minute /10;
    byte digi4 = val_minute %10;

    sevenSegment(digi1 , OFF);
    ControlSegmentDigi(0);

    sevenSegment(digi2 , OFF);
    ControlSegmentDigi(1);
    
    if ((dp_count > 40) && (dp == BLINK )) {
      dp = OFF;
      dp_count = 0;
    }
    
    sevenSegment(digi3 ,dp);
    ControlSegmentDigi(2);

    sevenSegment(digi4 ,dp);
    ControlSegmentDigi(3);
    
   }
   
   
    if (millis() - previousMillis > 500) {
    
        previousMillis = millis();   // remember the last time we blinked the LED    

        getClock();        
    
        dp = BLINK;
    
    }
        
    for(i=0; i<NUM_KEYS; i++){
                 
        if(key[i].button_flag !=0)
        {            
           key[i].button_flag=0;  // reset button flag
           
 	    switch(i)
            {
      	    case UP_KEY:
              val_minute++;
              break;
    	    case DOWN_KEY:
              val_minute--;
	      break;
            case OK_KEY:        
              //return Dec2bcd(val);
              STATE = 1;              
              break;   
            case CANCEL_KEY:
              //Serial.println("CANCEL");              
              return;
	    }

	}

  if (val_minute > 59) val_minute = 0;
  if (val_minute < 0) val_minute = 59;
      
  }
   
  }

  time.minute = Dec2bcd(val_minute);
  
  setClock();
  
}
