/// function for ds1307 ///////
#include <Wire.h>

// DS1307 clock registers
#define DS1307      0xD0 >> 1                   // shift required by Wire.h (silly...)
#define R_SECS      0
#define R_MINS      1
#define R_HRS       2
#define R_WKDAY     3
#define R_DATE      4
#define R_MONTH     5
#define R_YEAR      6
#define R_SQW       7



void init_ds1307()
{
    Wire.begin(); // Initial I2C    
}

void setClock()
{
    Wire.beginTransmission(DS1307);
    Wire.send(R_SECS);
    Wire.send(time.second);
    Wire.send(time.minute);
    Wire.send(time.hour);
    Wire.send(time.wkDay);
    Wire.send(time.day);
    Wire.send(time.month);
    Wire.send(time.year);
    Wire.send(time.ctrl);
    Wire.endTransmission();
}


void getClock()
{
    Wire.beginTransmission(DS1307);
    Wire.send(R_SECS);
    Wire.endTransmission();
    
    Wire.requestFrom(DS1307, 8);
    time.second = Wire.receive();
    time.minute = Wire.receive();
    time.hour   = Wire.receive();
    time.wkDay  = Wire.receive();
    time.day    = Wire.receive();
    time.month  = Wire.receive();
    time.year   = Wire.receive();
    time.ctrl   = Wire.receive();
}


byte bcd2Dec(byte bcdVal)
{
 return bcdVal / 16 * 10 + bcdVal % 16;
}

byte Dec2bcd(byte DecVal)
{
  return DecVal/10*16 + DecVal % 10;
}
